/* AUTOGENERATED FILE. DO NOT EDIT. */
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "cmock.h"
#include "mock_led.h"

static const char* CMockString_led_exec = "led_exec";
static const char* CMockString_led_init = "led_init";

typedef struct _CMOCK_led_init_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;

} CMOCK_led_init_CALL_INSTANCE;

typedef struct _CMOCK_led_exec_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  uint8_t ReturnVal;

} CMOCK_led_exec_CALL_INSTANCE;

static struct mock_ledInstance
{
  char led_init_IgnoreBool;
  char led_init_CallbackBool;
  CMOCK_led_init_CALLBACK led_init_CallbackFunctionPointer;
  int led_init_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE led_init_CallInstance;
  char led_exec_IgnoreBool;
  uint8_t led_exec_FinalReturn;
  char led_exec_CallbackBool;
  CMOCK_led_exec_CALLBACK led_exec_CallbackFunctionPointer;
  int led_exec_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE led_exec_CallInstance;
} Mock;

extern jmp_buf AbortFrame;

void mock_led_Verify(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_MEM_INDEX_TYPE call_instance;
  call_instance = Mock.led_init_CallInstance;
  if (Mock.led_init_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_led_init);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.led_init_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.led_exec_CallInstance;
  if (Mock.led_exec_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_led_exec);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.led_exec_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
}

void mock_led_Init(void)
{
  mock_led_Destroy();
}

void mock_led_Destroy(void)
{
  CMock_Guts_MemFreeAll();
  memset(&Mock, 0, sizeof(Mock));
}

void led_init(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_led_init_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_led_init);
  cmock_call_instance = (CMOCK_led_init_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.led_init_CallInstance);
  Mock.led_init_CallInstance = CMock_Guts_MemNext(Mock.led_init_CallInstance);
  if (Mock.led_init_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.led_init_CallbackBool &&
      Mock.led_init_CallbackFunctionPointer != NULL)
  {
    Mock.led_init_CallbackFunctionPointer(Mock.led_init_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.led_init_CallbackFunctionPointer != NULL)
  {
    Mock.led_init_CallbackFunctionPointer(Mock.led_init_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void led_init_CMockIgnore(void)
{
  Mock.led_init_IgnoreBool = (char)1;
}

void led_init_CMockStopIgnore(void)
{
  Mock.led_init_IgnoreBool = (char)0;
}

void led_init_CMockExpect(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_led_init_CALL_INSTANCE));
  CMOCK_led_init_CALL_INSTANCE* cmock_call_instance = (CMOCK_led_init_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.led_init_CallInstance = CMock_Guts_MemChain(Mock.led_init_CallInstance, cmock_guts_index);
  Mock.led_init_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
}

void led_init_AddCallback(CMOCK_led_init_CALLBACK Callback)
{
  Mock.led_init_IgnoreBool = (char)0;
  Mock.led_init_CallbackBool = (char)1;
  Mock.led_init_CallbackFunctionPointer = Callback;
}

void led_init_Stub(CMOCK_led_init_CALLBACK Callback)
{
  Mock.led_init_IgnoreBool = (char)0;
  Mock.led_init_CallbackBool = (char)0;
  Mock.led_init_CallbackFunctionPointer = Callback;
}

uint8_t led_exec(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_led_exec_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_led_exec);
  cmock_call_instance = (CMOCK_led_exec_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.led_exec_CallInstance);
  Mock.led_exec_CallInstance = CMock_Guts_MemNext(Mock.led_exec_CallInstance);
  if (Mock.led_exec_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    if (cmock_call_instance == NULL)
      return Mock.led_exec_FinalReturn;
    Mock.led_exec_FinalReturn = cmock_call_instance->ReturnVal;
    return cmock_call_instance->ReturnVal;
  }
  if (!Mock.led_exec_CallbackBool &&
      Mock.led_exec_CallbackFunctionPointer != NULL)
  {
    uint8_t cmock_cb_ret = Mock.led_exec_CallbackFunctionPointer(Mock.led_exec_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return cmock_cb_ret;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.led_exec_CallbackFunctionPointer != NULL)
  {
    cmock_call_instance->ReturnVal = Mock.led_exec_CallbackFunctionPointer(Mock.led_exec_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
  return cmock_call_instance->ReturnVal;
}

void led_exec_CMockIgnoreAndReturn(UNITY_LINE_TYPE cmock_line, uint8_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_led_exec_CALL_INSTANCE));
  CMOCK_led_exec_CALL_INSTANCE* cmock_call_instance = (CMOCK_led_exec_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.led_exec_CallInstance = CMock_Guts_MemChain(Mock.led_exec_CallInstance, cmock_guts_index);
  Mock.led_exec_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  Mock.led_exec_IgnoreBool = (char)1;
}

void led_exec_CMockStopIgnore(void)
{
  if(Mock.led_exec_IgnoreBool)
    Mock.led_exec_CallInstance = CMock_Guts_MemNext(Mock.led_exec_CallInstance);
  Mock.led_exec_IgnoreBool = (char)0;
}

void led_exec_CMockExpectAndReturn(UNITY_LINE_TYPE cmock_line, uint8_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_led_exec_CALL_INSTANCE));
  CMOCK_led_exec_CALL_INSTANCE* cmock_call_instance = (CMOCK_led_exec_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.led_exec_CallInstance = CMock_Guts_MemChain(Mock.led_exec_CallInstance, cmock_guts_index);
  Mock.led_exec_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void led_exec_AddCallback(CMOCK_led_exec_CALLBACK Callback)
{
  Mock.led_exec_IgnoreBool = (char)0;
  Mock.led_exec_CallbackBool = (char)1;
  Mock.led_exec_CallbackFunctionPointer = Callback;
}

void led_exec_Stub(CMOCK_led_exec_CALLBACK Callback)
{
  Mock.led_exec_IgnoreBool = (char)0;
  Mock.led_exec_CallbackBool = (char)0;
  Mock.led_exec_CallbackFunctionPointer = Callback;
}

